/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.artifacts.uinfo.salix;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;
import org.dive4elements.artifacts.Artifact;
import org.dive4elements.artifacts.CallContext;
import org.dive4elements.artifacts.common.utils.XMLUtils.ElementCreator;
import org.dive4elements.river.artifacts.sinfo.SINFOArtifact;
import org.dive4elements.river.artifacts.sinfo.collision.CollisionAccess;
import org.dive4elements.river.artifacts.states.AddTableDataHelper;
import org.dive4elements.river.artifacts.states.DefaultState;
import org.dive4elements.river.model.sinfo.Collision;
import org.w3c.dom.Element;

/** State in which to fetch years for sedminent load calculation. */
public class LoadMultipleYearSelectState extends DefaultState {
    private static final long serialVersionUID = 1L;
    /** The log used in this class. */
    private static Logger log = Logger.getLogger(LoadMultipleYearSelectState.class);

    /**
     * The default constructor that initializes an empty State object.
     */
    public LoadMultipleYearSelectState() {
    }

    /** Year Select Widget. */
    @Override
    protected String getUIProvider() {
        return "sinfo.collision.load_year_select";
    }

    @Override
    protected void appendItems(final Artifact artifact, final ElementCreator creator, final String name, final CallContext context, final Element select) {
        // TODO: MAKE DATASOURCE
        try {
            final String dataKeyofState = "years";// siehe sinfo.xml
            if (dataKeyofState.equals(name)) {

                final AddTableDataHelper helper = new AddTableDataHelper(creator, select, "year", context.getMeta()); // "year" not to be confused with datakey

                helper.addColumn(0, "pinfrom", "60", "common.client.ui.selection", "ICON", "CENTER", "from");
                helper.addColumn(1, "year", "60", "year", "INTEGER", "LEFT", null);

                final CollisionAccess access = new CollisionAccess((SINFOArtifact) artifact); // Der River wurde im vorigen State bereits gesetzt

                // final List<Collision> collisions = CollisionHibernateFactory.getCollisionsByRiver(access.getRiver());
                // for (final Collision coll : collisions) {
                for (final Integer year : Collision.getYearsOfRiver(access.getRiver())) {
                    // final Integer year = coll.getYear();
                    final Map<String, String> row = new HashMap<>();
                    row.put("year", year.toString()); // Nullpointer?
                    helper.addRow(row);
                }
                helper.submitMapToXml();
            }
        }
        catch (final IllegalArgumentException iae) {
            iae.printStackTrace();
        }
    }

    @Override
    public void validate(final Artifact artifact, final CallContext cc) throws IllegalArgumentException {
        // TODO: check verstehen

        final CollisionAccess access = new CollisionAccess((SINFOArtifact) artifact);

        // Second year should be later than first.

        // if (access.getYears() == null || access.getYears().length == 0)
        // return true;
        // throw new IllegalArgumentException("error_years_wrong");

        // return true;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf-8 :
